<template>
  <single-panel v-if="localOrders">
    <div class="simple-orders">
      <filter-panel v-show="Object.keys(localOrders).length"/>
      <ob-table
        v-if="localOrders"
        :columns="orderColumns"
        :functionalPanel="true"
        :items="localOrders"
        :loading="tableLoading"
        :tableLayoutFixed="false"
        :showAddButton="true"
        addButtonText="Создать предзаказ"
        @add="onAdd"
        data-qa="orderSimpleTable"
        ref="obTableSimpleOrders"
        is-fixed-header
      >
        <template v-slot:summ="{ data }">
          <div class="summ">
            <span class="error" v-if="!data.item.contracts || (data.item.contracts && !data.item.contracts.length)"
              >Нет договора</span
            >
            <ob-inline-select
              v-else
              :value="data.item.contractUuid"
              :items="data.item.contracts"
              label="Выберите"
              :maxWidth="130"
              :displayExpr="data.item.clientExternalNumber ? 'clientExternalNumber' : 'number'"
              popper-class="contracts-dropdown"
              isRequired
              :inherit-width="false"
              @input="setField($event, data.item, 'contractUuid')"
              data-qa="contractUuid"
            />
            <ob-input
              :value="data.item.rateWithoutVat"
              required
              placeholder="Введите"
              subTitle="₽"
              type="money:2"
              @input="setField($event, data.item, 'rateWithoutVat')"
              data-qa="rateWithoutVat"
            />
          </div>
        </template>

        <template v-slot:submit="{ data }">
          <div class="submit">
            <p>
              {{ data.item.number }}
            </p>
            <ob-button
              v-if="data.item.status === 'READY_TO_FORM'"
              label="Оформить"
              @click="onPublish(data.item)"
              data-qa="submitButton"
            />
            <span v-else> Не хватает данных</span>
          </div>
        </template>

        <template v-slot:actions="{ data }">
          <ob-menu-dropdown
            :items="[
              {
                title: 'Редактировать',
                icon: 'edit',
                method: () => onClickAction(data.item, 'edit'),
              },
              { title: 'Создать копию', icon: 'copy-2', method: () => onClickAction(data.item, 'copy') },
              { title: 'Удалить', icon: 'trash', className: 'color-error', method: () => onClickAction(data.item, 'delete') },
            ]"
            trigger="click"
            data-qa="actionsMenu"
          />
        </template>

        <template v-slot:clientForClicar="{ data }">
          <div class="client">
            <ob-inline-select
              :value="data.item.clientUuid"
              :items="participants"
              label="Выберите"
              :maxWidth="130"
              popper-class="participants-dropdown"
              isRequired
              :inherit-width="false"
              @input="changeClientOrContractor($event, data.item, 'clientUuid')"
              data-qa="clientUuid"
            />
            <ob-input
              :value="data.item.externalNumber"
              placeholder="№ заказа"
              @input="setField($event, data.item, 'externalNumber')"
              data-qa="externalNumber"
            />
          </div>
        </template>

        <template v-slot:clientForClient="{ data }">
          <div class="client">
            <ob-inline-select
              :value="data.item.contractorUuid"
              :items="participants"
              label="Выберите"
              :maxWidth="130"
              popper-class="participants-dropdown"
              isRequired
              :inherit-width="false"
              @input="changeClientOrContractor($event, data.item, 'contractorUuid')"
              data-qa="clientUuid"
            />
            <ob-input
              :value="data.item.externalNumber"
              placeholder="№ заказа"
              @input="setField($event, data.item, 'externalNumber')"
              data-qa="externalNumber"
            />
          </div>
        </template>

        <template v-slot:dateFrom="{ data }">
          <ob-date-picker
            :value="data.item.loadingDate"
            blockBefore
            label=""
            :isTime="true"
            :timeInterval="15"
            @input="setField($event, data.item, 'loadingDate')"
            data-qa="loadingDate"
          />
        </template>

        <template v-slot:fromAddress="{ data }">
          <div class="address">
            <div class="location">
              <template v-if="data.item.fromAddress.baseLocationTitle">
                <span>Опорник: </span>
                {{ data.item.fromAddress.baseLocationTitle }}
              </template>
            </div>
            <ob-address-input
              :address="data.item.fromAddress.addressRu"
              :locationsTypes="locationsTypes"
              prefixIcon="pin"
              placeholder="Погрузка"
              isNoLocations
              mapId="map-2"
              :showMap="false"
              customIcon="map"
              customAction
              isRadius
              @input="setField($event, data.item, 'fromAddress')"
              @customAction="onOpenMapModal(data.item.fromAddress, 'from', data.item.uuid)"
              data-qa="fromAddress"
            />
          </div>
        </template>

        <template v-slot:toAddress="{ data }">
          <div class="address">
            <div class="location">
              <template v-if="data.item.toAddress.baseLocationTitle">
                <span v-if="data.item.toAddress.baseLocationTitle">Опорник: </span>
                {{ data.item.toAddress.baseLocationTitle }}
              </template>
            </div>
            <ob-address-input
              :address="data.item.toAddress.addressRu"
              :locationsTypes="locationsTypes"
              prefixIcon="pin"
              placeholder="Разгрузка"
              isNoLocations
              mapId="map-3"
              :showMap="false"
              customIcon="map"
              customAction
              isRadius
              @input="setField($event, data.item, 'toAddress')"
              @customAction="onOpenMapModal(data.item.toAddress, 'to', data.item.uuid)"
              data-qa="toAddress"
            />
          </div>
        </template>

        <template v-slot:resource="{ data }">
          <div class="resource">
            <ob-inline-select
              :value="data.item.serviceUuid"
              :items="resources"
              valueLabelExpr="shortTitle"
              groupDisplayExpr="serviceTypeTitle"
              groupChildExpr="services"
              isGrouped
              label="Выберите"
              popper-class="resources-dropdown"
              isRequired
              :inherit-width="false"
              @input="setField($event, data.item, 'serviceUuid')"
              data-qa="serviceUuid"
            />
            <div class="resource-pattern">
              {{ data.item.resourcePatternRu }}
            </div>
          </div>
        </template>

        <template v-slot:insurance="{ data }">
          <ob-inline-select
            :value="data.item.cargoTypeUuid"
            :items="cargoTypes"
            displayExpr="name"
            label="Выберите"
            :maxWidth="170"
            isRequired
            :inherit-width="false"
            @input="setField($event, data.item, 'cargoTypeUuid')"
            data-qa="cargoTypeUuid"
          />
          <ob-input
            :value="data.item.cargoInsuranceCost"
            subTitle="₽"
            type="money:0"
            placeholder="Укажите"
            @input="setField($event, data.item, 'cargoInsuranceCost')"
            data-qa="cargoInsuranceCost"
          />
        </template>

        <template v-slot:consignor="{ data }">
          <ob-inline-select
            v-if="data.item.consignors && data.item.consignors.length"
            :value="data.item.consignorUuid"
            :items="data.item.consignors"
            label="Выберите"
            :maxWidth="170"
            isRequired
            :inherit-width="false"
            @input="setField($event, data.item, 'consignorUuid')"
            data-qa="consignorUuid"
          />
        </template>

        <template v-slot:consignee="{ data }">
          <ob-inline-select
            v-if="data.item.consignees && data.item.consignees.length"
            :value="data.item.consigneeUuid"
            :items="data.item.consignees"
            label="Выберите"
            :maxWidth="170"
            isRequired
            @input="setField($event, data.item, 'consigneeUuid')"
            data-qa="consigneeUuid"
          />
        </template>

        <template v-slot:logist="{ data }">
          <div class="logist">
            <!-- <span
              class="only"
              v-if="(data.item.logistsList && data.item.logistsList.length === 1) && (data.item.logistUuid && data.item.logistUuid.length)"
            >
              {{ oneLogist(data.item) }}
            </span> -->
            <ob-inline-select
              v-if="data.item.logistsList && data.item.logistsList.length"
              :value="data.item.logistUuid"
              :items="data.item.logistsList"
              label="Выберите"
              :maxWidth="170"
              isRequired
              :inherit-width="false"
              @input="setField($event, data.item, 'logistUuid')"
              data-qa="logistUuid"
            />
            <span
              class="more-logists"
              v-if="data.item.logistsList && data.item.logistsList.length > 1 && data.item.logistUuid && data.item.logistUuid.length"
            >
              Ещё {{ data.item.logistsList.length - 1 }}
            </span>
          </div>
        </template>

        <template v-slot:contactPersonFio="{ data }">
          <div class="logist">
            <ob-inline-select
              :value="data.item.contactPersonFio"
              :items="contactFios"
              label="Выберите"
              :maxWidth="170"
              :inherit-width="false"
              @input="setField($event, data.item, 'contactPersonFio')"
              data-qa="contactPersonFio"
            />
          </div>
        </template>
      </ob-table>
    </div>
    <AddressMapModal
      ref="mapModal"
      :data-source="{ address: {} }"
      :value="activeAddress"
      :zoom="
        this.activeAddress.icon === 'pin' && this.activeAddress.label.length
          ? 15
          : 8
      "
      isNoLocations
      :locationsTypes="locationsTypes"
      :direction="activeDirection"
      @input="setAddressFromModal"
      data-qa="addressModal"
    />
    <delete-popup
        ref="deleteOrder"
        @close="$refs.deleteOrder.close()"
        @delete="onDeleteOrder"
    >
      <p>
        Черновик будет удалён без возможности восстановления.
      </p>
    </delete-popup>
  </single-panel>
</template>

<script>
import cloneDeep from 'clone-deep'
import api from "@/api";
import { uuid } from "vue-uuid";
import { mapGetters } from "vuex";
import debounce from "debounce";
import SinglePanel from "common-components/src/obComponents/obSinglePanels";
import FilterPanel from "./filterPanel";
import ObTable from "common-components/src/obComponents/obTable";
import ObInput from "common-components/src/obComponents/obInput";
import ObButton from "common-components/src/obComponents/obButton";
import obInlineSelect from "common-components/src/obComponents/obInlineSelect";
import obDatePicker from "common-components/src/obComponents/obDatePickerConstructor";
import ObAddressInput from "common-components/src/obComponents/obAddressInput";
import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown";
import AddressMapModal from "@/pages/logchainPage/components/logchainMapModal";
import DeletePopup from "@/components/Order/modal/DeleteOrder";

export default {
  name: "orderAllSimple",

  components: {
    SinglePanel,
    FilterPanel,
    ObTable,
    ObInput,
    ObButton,
    obInlineSelect,
    obDatePicker,
    ObAddressInput,
    ObMenuDropdown,
    AddressMapModal,
    DeletePopup,
  },

  data() {
    return {
      localOrders: [],
      participants: [],
      cargoTypes: [],
      resources: [],
      contactFios: [],
      activeAddress: {},
      activeDirection: "from",
      locationsTypes: [],
      actionItem: null,
      tableLoading: false,
    };
  },

  computed: {
    ...mapGetters({
      role: "user/role",
      isClicar: "user/isClicar",
      isClient: "user/isClient",
      participantUuid: "user/participantUuid"
    }),

    orderColumns() {
      const columns = [];

      columns.push({
        title: "Сумма заказа без НДС",
        key: "rateWithoutVat",
        width: 160,
        slotName: "summ",
      })

      columns.push({
        title: "Оформить заказ",
        width: 140,
        slotName: "submit",
      })

      columns.push({
        title: "",
        slotName: "actions",
        action: true,
        isToggleDisabled: true
      })

      if (this.isClicar) {
        columns.push({
          title: "Заказчик",
          key: "clientUuid",
          slotName: "clientForClicar",
          width: 180,
        })
      }

      if (this.isClient) {
        columns.push({
          title: "Исполнитель",
          key: "contractortUuid",
          slotName: "clientForClient",
          width: 180,
        })
      }

      columns.push({
        title: "Плановая дата погрузки",
        key: "loadingDate",
        slotName: "dateFrom",
        width: 220,
      })

      columns.push({
        title: "Адрес погрузки",
        key: "fromAddress",
        slotName: "fromAddress",
        width: 200,
      })

      columns.push({
        title: "Адрес разгрузки",
        key: "toAddress",
        slotName: "toAddress",
        width: 200,
      })

      columns.push({
        title: "Способ перевозки",
        key: "resourceTitleRu",
        slotName: "resource",
      })

      columns.push({
        title: "Тип груза и страховая стоимость",
        key: "cargoInsuranceCost",
        slotName: "insurance",
        width: 200,
      })

      columns.push({
        title: "Грузо-отправитель",
        key: "consignorUuid",
        slotName: "consignor",
      })

      columns.push({
        title: "Грузо-получатель",
        key: "consigneeUuid",
        slotName: "consignee",
      })

      if (this.isClicar) {
        columns.push({
          title: "Ответственный логист",
          key: "logistTitle",
          slotName: "logist",
        })
      }

      if (this.isClient) {
        columns.push({
          title: "Контактное лицо",
          key: "contactPersonFio",
          slotName: "contactPersonFio",
        })
      }

      return columns;
    },
  },

  async mounted() {
    try {
      await this.getOrders();
      this.participants = await this.getParticipants();
      this.cargoTypes = await this.getCargoTypes();
      this.resources = await this.getResources();
      this.locationsTypes = await this.getLocationTypes();
      if (this.isClient) {
        const contactFios = await this.getContactFios();
        this.contactFios = contactFios.map(fio => {
          return {
            title: fio,
            uuid: fio
          }
        })
      }
    } catch (err) {
      console.error(err)
    }
  },

  methods: {
    async getOrders({ page, size, sort = "created_at,desc", query } = {}) {
      this.tableLoading = true;
      const altSort = sort?.split(",");
      try {
        const res = await api.orders.getSimpleOrders({
          page,
          size,
          field: altSort[0],
          direction: altSort[1],
          query,
        });
        const data = [];
        for (const item of res) {
          let temp = { ...item }
          temp.contracts = [];
          temp.logistsList = [];
          temp.consignors = [];
          temp.consignees = [];
          if (temp.clientUuid && temp.contractorUuid) {
            temp = await this.getOrderInfo(item);
          }
          data.push(temp);
        }
        this.localOrders = data;
        this.tableLoading = false;
        return {
          content: data,
          numberOfElements: data.length,
          page: 0,
          size: data.length,
          totalElements: data.length,
          totalPages: 1
        };
      } catch (e) {
        console.error(e);
      }
    },

    async getOrderInfo(item) {
      const temp = { ...item };
      try {
        temp.logistsList = this.isClicar ? await this.getLogistsList(item.contractorUuid, item.clientUuid) : null;
        temp.contracts = await this.getContracts(item.clientUuid, item.contractorUuid, new Date());
        if (temp.contracts.length === 1) {
          temp.contractUuid = temp.contracts[0].uuid;
          temp.contractNumber = temp.contracts[0].number;
        }
        temp.consignors = await this.getConsignors(temp.clientUuid);
        temp.consignees = await this.getConsgnees(temp.clientUuid);
        return temp;
      } catch (err) {
        console.error(err);
      }
    },

    async getParticipants() {
      const role = this.isClicar ? "CLIENT" : "CLICAR,CARRIER";
      try {
        const res = await api.organisations.getParticipantsbyRoleWithColor(role);
        return res.data;
      } catch (err) {
        console.error(err);
      }
    },

    async getResources() {
      try {
        const res = await api.orders.getServicesForSimpleOrders('FTL');
        const data = res.map(group => {
          group.services = group.services.map(item => {
            return {
              title: `${item.resourceTitle} ${item.resourcePattern}`,
              shortTitle: item.resourceTitle,
              pattern: item.resourcePattern,
              uuid: item.serviceUuid
            }
          })
          return group;
        });
        return data;
      } catch (err) {
        console.error(err);
      }
    },

    async getCargoTypes() {
      try {
        const res = await api.cargo.getCargoTypes();
        return res.content;
      } catch (err) {
        console.error(err);
      }
    },

    async getConsignors(uuid) {
      try {
        const res = await api.contractors.getContractorsByType({ ownerUuid: uuid, type: "CONSIGNOR" });
        return res.data.list;
      } catch (err) {
        console.error(err);
      }
    },

    async getConsgnees(uuid) {
      try {
        const res = await api.contractors.getContractorsByType({ ownerUuid: uuid, type: "CONSIGNEE" });
        return res.data.list;
      } catch (err) {
        console.error(err);
      }
    },

    async getContracts(clientUuid, contractorUuid) {
      try {
        const res = await api.orders.fetchContracts({ clientUuid, contractorUuid, actualDate: new Date() });
        return res.contracts;
      } catch (err) {
        console.error(err);
      }
    },

    async getLogistsList(contractorUuid, clientUuid) {
      try {
        const res = await api.orders.getLogistsList(contractorUuid, clientUuid);
        return res.map((item) => {
          return {
            uuid: item.uuid,
            title: `${item.firstname} ${item.lastname}`,
          };
        });
      } catch (err) {
        console.error(err);
      }
    },

    async getLocationTypes() {
      try {
        const res = await api.locations.getLocationTypes();
        return res.data.content;        
      } catch (err) {
        console.error(err);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных",
        }); 
      }
    },

    async getContactFios() {
      try {
        const res = await api.orders.getOrderContacts(this.participantUuid);
        return res.data;
      } catch (err) {
        console.error(err);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных",
        });
      }
    },

    async changeClientOrContractor(e, item, fieldName) {
      this.setField(e, item, fieldName);
      item.consigneeUuid = null;
      item.consigneeTitle = null;
      item.consignorUuid = null;
      item.consignorTitle = null;
      item.logistUuid = null;
      item.logistTitle = null;
      item.contractNumber = null;
      item.contractUuid = null;

      const clientUuid = fieldName === 'clientUuid' ? e : item.clientUuid;
      const contractorUuid = fieldName === 'contractorUuid' ? e : item.contractorUuid;
      item.consignors = await this.getConsignors(clientUuid);
      item.consignees = await this.getConsgnees(clientUuid);
      item.logistsList = await this.getLogistsList(contractorUuid, clientUuid);
      item.contracts = await this.getContracts(clientUuid, contractorUuid, new Date());
      if (item.contracts.length === 1) {
        item.contractUuid = item.contracts[0].uuid;
        item.contractNumber = item.contracts[0].number;
      }
    },

    getOrder(uuid) {
      return this.localOrders.find((item) => item.uuid === uuid);
    },

    setField: debounce(async function($event, data, field) {
      const bak = cloneDeep(data[field]);
      const resourcePatternBak = data.resourcePatternRu;
      const resourceTitleBak = data.resourceTitleRu;
      const statusBak = data.status;
      data[field] = $event;
      if (field === 'fromAddress' || field === 'toAddress') {
        data[field].coordinates = $event.coordinates;
        data[field].addressRu = $event.label;
        data[field].locationTypeIcon = $event.locationTypeIcon;
        data[field].locationUuid = $event.locationUuid;
        data[field].baseLocationTitle = $event.locationTitle;
      }
      if (field === 'serviceUuid') {
        const res = this.resources.reduce((acc, item) => {
          const data = item.services.find(child => child.uuid === $event)
          if (data) {
            acc = data
          }
          return acc;
        }, {})
        data.resourcePatternRu = res.pattern;
        data.resourceTitleRu = res.shortTitle;
      }
      try {
        const saved = await api.orders.createSimpleOrder(data.uuid, data);
        data.status = saved.data.status;
      } catch (err) {
        data[field] = bak;
        data.resourcePatternRu = resourcePatternBak;
        data.resourceTitleRu = resourceTitleBak;
        data.status = statusBak;
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалось сохранить'
        })
        console.error(err);
      }
    }, 1000),

    async onClickAction(item, action) {
      this.actionItem = item;
      switch (action) {
        case 'delete': {
          this.$refs.deleteOrder.open();
          break;
        }
        case 'copy': {
          await this.onCopy(item)
          break;
        }
        default: {
          console.log('edit ->', {item, action});
        }
      }
    },

    oneLogist(order) {
      if (order.logistsList && order.logistsList.length > 1) return;
      const logist = order.logistsList.find(
        (item) => item.uuid === order.logistUuid
      );
      return logist.title;
    },

    async onCopy(item) {
      try {
        const newUuid = uuid.v4();
        const number = await api.orders.getOrderId('Order');
        await api.orders.createSimpleOrder(newUuid, { ...item, number: number.data.code });
        await this.getOrders();
      } catch (err) {
        console.error(err);
      }
    },

    async onAdd() {
      try {
        const code = await api.orders.getOrderId('Order');
        const newUuid = uuid.v4();
        const date = new Date();
        date.setDate(date.getDate() + 1);
        date.setHours(12, 0, 0);
        const payload = {
          uuid: newUuid,
          number: code.data.code,
          loadingDate: date,
          contractorUuid: this.isClicar ? this.participantUuid : null,
          clientUuid: this.isClient ? this.participantUuid : null,
        }
        await api.orders.createSimpleOrder(newUuid, payload);
        this.getOrders();
      } catch (e) {
        console.error(e);
      }
    },

    async onPublish(item) {
      try {
        await api.orders.publishSimpleOrder(item.uuid);
        await this.getOrders();
      } catch (err) {
        console.error(err);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалось оформить заказ'
        })
      }
    },

    onOpenMapModal(address, direction, orderUuid) {
      this.activeDirection = direction;

      this.activeAddress = {
        coordinates: address.coordinates || {lat: '', lon: ''},
        label: address.addressRu || '',
        locationTitle: address.baseLocationTitle || "",
        icon: "pin",
        isValid: true,
        popoverMessage: "",
        item: orderUuid
      };
      this.$nextTick(() => {
        this.$refs.mapModal.open();
      });
    },

    setAddressFromModal(e) {
      const target = this.localOrders.find(order => order.uuid === this.activeAddress.item);
      const addr = {
        coordinates: {
          lat: e.payload.coordinates.lat,
          lon: e.payload.coordinates.long,
        },
        icon: e.payload.icon,
        label: e.payload.label,
        locationTypeIcon: e.payload.locationTypeIcon || "CITY-SM",
        locationUuid: e.payload.uuid || e.payload.locationUuid || "",
        locationTitle: e.payload.locationTitle || ""
      };
      if (e.direction === "from") {
        this.setField(addr, target, 'fromAddress')
      } else {
        this.setField(addr, target, 'toAddress')
      }
    },
    async onDeleteOrder() {
      this.$refs.deleteOrder.close();
      if (this.actionItem) {
        try {
          await api.orders.deleteSimpleOrder(this.actionItem.uuid);
          this.localOrders = this.localOrders.filter(item => item.uuid !== this.actionItem.uuid);
          this.actionItem = null;
        } catch (err) {
          console.error(err);
          this.$notification({
            type: 'system_notification_error',
            message: 'Не удалось удалить заказ'
          })
        }
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.simple-orders {
  font-size: 14px;
}

.summ {
  display: flex;
  flex-direction: column;

  span {
    margin-bottom: 3px;
    color: $gray-slate;
  }
}

.submit {
  display: flex;
  flex-direction: column;

  p {
    margin: 0 0 3px;
  }

  span {
    @include font-mixin(12px, 14px, 400, $gray-slate);
  }
}

.address {
  display: flex;
  flex-direction: column;
}

.location {
  margin-bottom: 8px;
  @include font-mixin(12px, 14px, 400, $shale-gray);

  &:empty {
    margin-bottom: 21px;
  }
}

.resource-pattern,
.more-logists {
  @include font-mixin(12px, 14px, 400, $shale-gray);
}

.only {
  color: $gray-slate;
}

span.error {
  color: $color-error;
}

::v-deep {
  // .ob-table-inner {
  //   min-height: calc(100vh - 170px);
  // }

  .ob-button-container {
    margin-top: 4px;
    padding: 0 15px;
    height: 30px;
  }

  .ob-button-container.primary-type {
    @include font-mixin(12px, 14px, 400, $style-white);
  }

  .input-group .input {
    height: 20px;
    font-size: 14px;
  }

  .ob-input-wrap {
    height: 30px;
  }

  .ob-input-wrap.--theme-default {
    border: 1px solid transparent;
  }

  .units {
    line-height: 13px;
  }

  tr:hover .ob-input-wrap.--theme-default {
    border-color: $color-grey-border;
  }

  tr:hover .ob-input-wrap:hover {
    border-color: $blue-300;
  }

  tr:hover .ob-input-wrap.--focused {
    border-color: $color-blue-navy-blue;
    box-shadow: inset 0 3px 6px rgba(25, 30, 50, 0.1);
  }

  .ob-inline-select {
    margin-bottom: 5px;
  }

  .ob-table-inner .ob-date-picker {
    margin-top: 24px;

    i {
      font-size: 13px;
    }
  }

  .ob-address-input i {
    font-size: 14px;
  }

  .ob-menu-dropdown-container
    .menu-dropdown-list__item.color-error
    button
    .col-left
    i:before {
    color: $color-error;
  }
}
</style>

<style lang="scss">
.participants-dropdown {
  min-width: 300px;
}

.resources-dropdown {
  min-width: 440px;
}
</style>
